// vim: foldmethod=marker
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

const CID = '@flock.com/html2text;1';
const IID = Components.interfaces.flockIHTML2TEXT;

const LIST_HEIGHT = 140; 
const ICON_HEIGHT = 100; 

const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
.getService(Components.interfaces.nsIClipboardHelper);

window.last_dragged_selection='';
window.next_shelfobject = '';

var gDeleteId = null;
var gShouldDelete = false;

var shelfObserver = {/*{{{*/
    onDragOver: function (event, flavor, session) { },
    onDragStart: function(event, transferData, action){
                 var h2t = Components.classes['@flock.com/html2text;1'].getService(Components.interfaces.flockIHTML2TEXT);
                 //for (i in event.target){ XXX('event.target '+i, event.target[i]); }
                 var item = event.target;
                 var src = item.src;
                 var txt;
                 // dump('DRAGGING SOURCE: ' + src + '\n');
                 switch (item.type){
                     case "link":
                         case "image": txt = item.url; break;
                     default: txt = h2t.convert(src);
                 } 
                 transferData.data=new TransferData();
                 transferData.data.addDataForFlavour("flock/shelficon", src);
                 transferData.data.addDataForFlavour("text/html", src);
                 transferData.data.addDataForFlavour("text/unicode", txt);
    },

    onDrop: function (evt, dropData, asession) {
                // Files from desktop are not supported
                // (for some reason, files appear as text/unicode)
                if ((dropData.flavour.contentType == "text/unicode") &&
                    (dropData.data.substring(0, 7) == "file://")) {
                    return false;
                }
                var data=flock_getMarkedUpSelection(evt,dropData,asession);
                gShelf.addObject(data);
                if (gShelf.previewMode) gShelf.setCloseTimeout(1000);
            },

    getSupportedFlavours: function(){
                          flavors=new FlavourSet();
                          flavors.appendFlavour('text/html');
                          flavors.appendFlavour('text/unicode');
                          flavors.appendFlavour('text/x-moz-url');
                          // flavors.appendFlavour('application/x-moz-file','nsIFile');
                          return flavors;
                      }
}/*}}}*/
